ITS#9307 --enable-<option>=mod requires --enable-modules

Provide a more specific diagnostic when configuring with
--enable-<option>=mod but not --enable-modules. Make this an error for
both backends and overlays, and remove the automatic fallback to static.
3 jobs for its9307 in 28 minutes and 39 seconds (queued for 1 second)